<template>
  <div class="add-participants-container">
    <ObTable
      ref="participants-table"
      :columns="columns"
      :remote-opt="{
        method: getContractors,
        arguments: {
          uuid: tenderInfo.uuid
        },
        contentKey: 'participants'
      }"
      :functional-panel="true"
      :table-layout-fixed="false"
      :is-functional-sort="false"
      :is-functional-group="false"
      :with-checkboxes="true"
      :checked-rows="selectedUuids"
      :group-by="isShowGroups ? 'group' : null"
      data-qa="tenderBuyerAddParticipantsTable"
      class="participants-table"
      @select="onSelect"
      @row-toggle="onToggle"
      @group-toggle="onGroupToggle"
    >
      <template slot="extraFuncButtons">
        <ObToggle
          :value="isShowGroups"
          label="Показывать группы контрагентов"
          class="groups-toggle"
          @change="onShowGroupsChanged"
        />
      </template>
    </ObTable>

    <div class="modal-custom-buttons">
      <ObButton
        :label="`Добавить ${selectedUuids.length ? plural(selectedUuids.length, ['участника', 'участника', 'участников']) : ''}`"
        :disabled="!selectedUuids.length"
        data-qa="btAdd"
        @click="onSubmit"
      />

      <ObButton
        label="Закрыть"
        type="flat"
        data-qa="btnClose"
        @click="onClose"
      />
    </div>
  </div>
</template>

<script>
  import api from '@/api'
  import { mapGetters } from 'vuex'
  
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObButton from 'common-components/src/obComponents/obButton'
  import ObToggle from 'common-components/src/obComponents/obSwitcherCheckbox'

  import participantsMixin from '../mixin/participantsMixin'

  export default {
    name: 'tender-tab-buyer-participants',
    mixins: [
      participantsMixin
    ],
    components: {
      ObTable,
      ObButton,
      ObToggle
    },
    computed: {
      ...mapGetters({
        tenderInfo: 'tenders/tenderInfo'
      })
    },
    data () {
      return {
        columns: [
          {
            fixed: true,
            key: 'title',
            title: 'Название контрагента',
            html: ({ shortTitle }) => shortTitle,
            headerHtml: () => this.isShowGroups ? 'Группа или контрагент' : 'Название контрагента'
          },
          {
            title: 'Телефон',
            key: 'phone'
          },
          {
            title: 'Эл. почта',
            key: 'email'
          },
          {
            title: 'Входит в группы',
            key: 'groups',
            sortDisable: true,
            width: '200',
            html: (data) => {
              return this.stringifyGroupsList(data)
            }
          }
        ],
        selectedUuids: []
      }
    },
    methods: {
      async getContractors({ page, size, query, sort, uuid }) {
        const response = await api.tenders[`getUnappliedTenderContractorsByUuid${this.isShowGroups ? 'ByGroups' : ''}`]({
          page, size, query, sort, uuid
        })

        return this.parseParticipants(response)
      },
      loadData () {
        this.$nextTick(() => {
          this.$refs['participants-table'].loadData({ init: true })
        })
      },
      // 👂 Events
      onSelect (e) {
        this.$emit('select', e)
      },
      onSubmit () {
        this.$emit('submit', this.selectedUuids)
      },
      onClose () {
        this.$emit('submit', null)
      },
      onShowGroupsChanged (value) {
        this.isShowGroups = value

        this.loadData()
      },
      async onGroupToggle (data, selectedUuids, index, isSelected) {
        const groupUuid = this.participantsGroups[index]

        let participants

        if (groupUuid) {
          ({ participants } = await api.tenders.getAllUnappliedTenderContractorsInGroup(this.tenderInfo.uuid, groupUuid))
        } else {
          ({ participants } = await api.tenders.getAllUnappliedTenderContractorsWithoutGroup(this.tenderInfo.uuid))
        }

        if (isSelected) {
          this.selectedUuids = this.selectedUuids.concat(participants.filter(uuid => !this.selectedUuids.includes(uuid)))
        } else {
          this.selectedUuids = this.selectedUuids.filter(uuid => !participants.includes(uuid))
        }

      },
      reset () {
        this.selectedUuids = []
        this.$refs['participants-table'].selectedUuids = []
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/assets/style/ob-style";
  @import "~common-components/src/static/css/mixins";

  .participants-table {
    border: 1px solid $lavender;
  }

  .groups-toggle::v-deep label {
    @include font-mixin(14px, 20px, 400, $color-text-base);
  }
  
  .modal-custom-buttons {
    margin-top: 40px;
    display: flex;
    align-items: center;
    justify-content: flex-start;

    &::v-deep {
      button:first-child {
        margin-right: 20px;
      }
    }
  }
</style>
